from django.db import models
from django.conf import settings
from django.contrib.auth.models import User

class Character(models.Model):
	chr_file = models.FileField(upload_to='bgate')
	name = models.CharField(maxlength=100)
	xp = models.PositiveIntegerField()
	hp = models.PositiveIntegerField()
	avatar = models.CharField(maxlength=100)
	strength = models.PositiveSmallIntegerField()
	inteligence = models.PositiveSmallIntegerField()
	wisdom = models.PositiveSmallIntegerField()
	charisma = models.PositiveSmallIntegerField()
	constitution = models.PositiveSmallIntegerField()
	dex = models.PositiveSmallIntegerField()
	race = models.CharField(maxlength=50)
	main_class = models.CharField(maxlength=50)
	gender = models.CharField(maxlength=50)
	attacks = models.PositiveSmallIntegerField()
	death_save = models.PositiveSmallIntegerField()
	wands_save = models.PositiveSmallIntegerField()
	polymorph_save = models.PositiveSmallIntegerField()
	breath_save = models.PositiveSmallIntegerField()
	spells_save = models.PositiveSmallIntegerField()
	fire = models.PositiveIntegerField()
	cold = models.PositiveIntegerField()
	elect = models.PositiveIntegerField()
	acid = models.PositiveIntegerField()
	magic = models.PositiveIntegerField()
	magic_fire = models.PositiveIntegerField()
	magic_cold = models.PositiveIntegerField()
	slash = models.PositiveIntegerField()
	pierce = models.PositiveIntegerField()
	blunt = models.PositiveIntegerField()
	missile = models.PositiveIntegerField()
	thaco = models.IntegerField()
	levels = models.PositiveIntegerField()
	kit = models.CharField(maxlength=255)
	alingment = models.CharField(maxlength=255)
	author = models.ForeignKey(User)
	comment = models.TextField(maxlength=500)
	class Meta:
		verbose_name = _('Baldurs Gate Character')
		verbose_name_plural = _('Baldurs Gate Characters')
		db_table = 'rk_baldur' + str(settings.SITE_ID)
	def get_absolute_url(self):
		return '/bgate/show/' + str(self.id) + '/'
	class Admin:
		list_display = ('name', 'author')
		search_fields = ['name', 'author']
	def __str__(self):
		return self.name