from django.shortcuts import render_to_response
from django import forms
from django.conf import settings
from baldur.models import *
from django.contrib.sites.models import Site
from django.template import RequestContext
from django.http import HttpResponseRedirect, HttpResponse

def chr_list(request, pagination_id=1):
	from django.views.generic.list_detail import object_list
	return object_list(request, Character.objects.all().order_by('-id'), paginate_by = 15, allow_empty = True, page = pagination_id, template_name = 'baldur/chr_list.html')


def chr_show(request, tid):
	try:
		char = Character.objects.get(id=tid)
	except:
		return render_to_response('pages/bug.html', {'bug': _('Character doesn\'t exist')}, context_instance=RequestContext(request))
	from boxcomments.models import Comment
	return render_to_response('baldur/chr_show.html', {'char':  char, 'com': Comment.objects.filter(apptype= 5, appid = tid).count()}, context_instance=RequestContext(request))

def get_chr(request, tid):
	tra = Character.objects.values('chr_file').get(id=tid)
	char = open(settings.MEDIA_ROOT + tra['chr_file']).read()
	e = HttpResponse()
	e['Content-Type'] = 'application/octet-stream'
	e['Content-Disposition'] = 'attachment; filename="postac.chr";'
	e.write(char)
	return e

def chrr(request):
	return render_to_response('baldur/chr.html', context_instance=RequestContext(request))
##################################################
class AddChInfo(forms.Manipulator):
	def __init__(self):
		self.fields = (forms.TextField(field_name="kit", length=30, maxlength=250, is_required=True),
		forms.LargeTextField(field_name="comments", is_required=True),)

class AddChInfoAvatar(forms.Manipulator):
	def __init__(self):
		self.fields = (forms.ImageUploadField(field_name="avatar", is_required=False),
		forms.TextField(field_name="kit", length=30, maxlength=250, is_required=True),
		forms.LargeTextField(field_name="comments", is_required=True),)


def add_info(request, tid):
	if request.user.is_authenticated():
		try:
			b = Character.objects.get(id=tid)
		except:
			return render_to_response('pages/bug.html', {'bug': _('Character doesn\'t exist')}, context_instance=RequestContext(request))
		if b.author != request.user:
			return render_to_response('pages/bug.html', {'bug': _('You aren\'t the author of this character')}, context_instance=RequestContext(request))
		pics = {'ELDOTHS': True, 'CORANS': True, 'ALORAS': True, 'EDWINS': True, 'BRANWES': True, 'DYNAHEIS': True, 'FALDORNS': True, 'GARRICKS': True, 'GENMELFS': True, 'JAHEIRAS': True, 'GENMHLFS': True, 'KAGAINS': True, 'IMOENS': True, 'KHALIDS': True, 'NAERIES': True, 'NANOMENS': True, 'NHORCS': True, 'MAN1S': True, 'KIVANS': True, 'GENDWRFS': True, 'MAN2S': True, 'MINSCS': True, 'NCERNDS': True, 'NEDWINS': True, 'NHAERS': True, 'NJAHEIRS': True, 'NJANS': True, 'MONTARS': True, 'NIMOENS': True, 'NMAZZYS': True, 'NKELDORS': True, 'NMINSCS': True, 'NVICONS': True, 'NKORGANS': True, 'NNALIAS': True, 'QUAYLES': True, 'NVALYGAS': True, 'NOPORTSM': True, 'SHARTELS': True, 'TIAXS': True, 'NYOSHIMS': True, 'SAFANAS': True, 'VICONIAS': True, 'SKIES': True, 'XANS': True, 'WOMAN1S': True, 'WOMAN2S': True, 'YESLICKS': True, 'XZARS': True, 'AJANTISS': True}
		if not pics.has_key(b.avatar):
			manipulator = AddChInfoAvatar()
			avatar = True
		else:
			manipulator = AddChInfo()
			avatar = False
		if request.POST:
			new_data = request.POST.copy()
			if avatar:
				new_data.update(request.FILES)
				if new_data.has_key('avatar') and new_data['avatar']['filename'].find('.jpg') == -1:
					errors['grafika'] = [_('Invalid filetype. Only JPG files are allowed')]
			errors = manipulator.get_validation_errors(new_data)
			if not errors:
				if new_data.has_key('avatar'):
					import sha, Image
					from os import remove
					nazwa_pliku = sha.new(new_data['avatar']['content']).hexdigest()
					a = open(settings.MEDIA_ROOT + '/bgate_av/' + nazwa_pliku + '.jpg', 'w')
					a.write(new_data['avatar']['content'])
					a.close()
					try:
						imi = Image.open(settings.MEDIA_ROOT + '/bgate_av/' + nazwa_pliku + '.jpg')
					except:
						errors['avatar'] = [_('Invalid image. Only JPG files are allowed')]
						form = forms.FormWrapper(manipulator, new_data, errors)
						remove(settings.MEDIA_ROOT + '/bgate_av/' + nazwa_pliku + '.jpg')
						return render_to_response('baldur/add_file2.html', {'form': form, 'avatar': avatar})
					size = imi.size
					if size[0] != 38 or size[1] != 60:
						errors['avatar'] = [_('Invalid size')]
						form = forms.FormWrapper(manipulator, new_data, errors)
						remove(settings.MEDIA_ROOT + '/bgate_av/' + nazwa_pliku + '.jpg')
						return render_to_response('baldur/add_file2.html', {'form': form, 'avatar': avatar})
					b.avatar = nazwa_pliku
				else:
					if not pics.has_key(b.avatar):
						b.avatar = 'NOPORTSM'
				
				manipulator.do_html2python(new_data)
				from stripogram import html2safehtml
				new_data['comments'] = html2safehtml(new_data['comments'] ,valid_tags=())
				new_data['kit'] = html2safehtml(new_data['kit'] ,valid_tags=())
				b.comment = new_data['comments']
				b.kit = new_data['kit']
				
				b.save()
				return HttpResponseRedirect('/bgate/show/' + str(b.id) + '/')
		else:
			errors = {}
			new_data = {}
			new_data['kit'] = _('None')
		form = forms.FormWrapper(manipulator, new_data, errors)
		return render_to_response('baldur/add_file2.html', {'form': form, 'avatar': avatar}, context_instance=RequestContext(request))
	else:
		return HttpResponseRedirect("/user/")

class AddCharacterFile(forms.Manipulator):
	def __init__(self):
		self.fields = (forms.FileUploadField(field_name="character", is_required=True),)

def add_file(request):
	if request.user.is_authenticated():
		manipulator = AddCharacterFile()
		if request.POST:
			new_data = request.POST.copy()
			new_data.update(request.FILES)
			errors = manipulator.get_validation_errors(new_data)
			if not errors:
				if new_data['character']['content'][0:3] != 'CHR' or new_data['character']['filename'].split('.')[-1].lower() != 'chr' or len(new_data['character']['content']) > 90000:
					errors['character'] = [_('Invalid File. Only Baldurs Gate CHR Character Files are allowed')]
					form = forms.FormWrapper(manipulator, new_data, errors)
					return render_to_response('baldur/add_file.html', {'form': form}, context_instance=RequestContext(request))
				else:
					import struct, sha
					nazwa_pliku = 'bgate/' + sha.new(new_data['character']['content']).hexdigest() + '.chr'
					plik = settings.MEDIA_ROOT + '/' + nazwa_pliku
					a = open(plik, 'wb')
					a.write(new_data['character']['content'])
					a.close()
					file = open(plik, 'rb')
					try:
						text = file.read()
					finally:
						file.close()
					char = {}
					if str(text[0x0000:0x0000+4]) == 'CHR ':
						char['ver'] = str(text[0x0004:0x0004+4])
						char['name'] = str(text[0x0008:0x0008+32])
						a = struct.unpack('i', text[0x0028:0x0028+4]) # offset do "pliku" CRE
						a = 0x0000+a[0]
						if str(text[a:a+4]) == 'CRE ' and str(text[a+4:a+8]) == 'V1.0':
							bugs = False
							char['xp'] = int(struct.unpack('i', text[a+0x0018:a+0x0018+4])[0])
							char['hp'] = int(struct.unpack('h', text[a+0x0024:a+0x0024+2])[0])
							char['pic'] = str(text[a+0x0034:a+0x0034+8])
							char['str'] = int(struct.unpack('b', text[a+0x0238:a+0x0238+1])[0]) #str
							char['int'] = int(struct.unpack('b', text[a+0x023a:a+0x023a+1])[0]) #int
							char['wis'] = int(struct.unpack('b', text[a+0x023b:a+0x023b+1])[0]) #wis
							char['dex'] = int(struct.unpack('b', text[a+0x023c:a+0x023c+1])[0]) #dex
							char['con'] = int(struct.unpack('b', text[a+0x023d:a+0x023d+1])[0]) #con
							char['char'] = int(struct.unpack('b', text[a+0x023e:a+0x023e+1])[0]) #char
							char['race'] = int(struct.unpack('b', text[a+0x0272:a+0x0272+1])[0]) # 1   HUMAN 2   ELF 3   HALF_ELF 4   DWARF 5   HALFLING 6   GNOME 7   HALFORC
							if char['race'] == 1:
								char['race'] = _('Human')
							elif char['race'] == 2:
								char['race'] = _('Elf')
							elif char['race'] == 3:
								char['race'] = _('Half elf')
							elif char['race'] == 4:
								char['race'] = _('Dwarf')
							elif char['race'] == 5:
								char['race'] = _('Halfling')
							elif char['race'] == 6:
								char['race'] = _('Gnome')
							elif char['race'] == 7:
								char['race'] = _('Half Orc')
							else:
								bugs = True
					
							char['class'] = int(struct.unpack('b', text[a+0x0273:a+0x0273+1])[0]) # 1   MAGE 2   FIGHTER 3   CLERIC 4   THIEF 5   BARD 6   PALADIN 7   FIGHTER_MAGE 8   FIGHTER_CLERIC 9   FIGHTER_THIEF 10  FIGHTER_MAGE_THIEF 11  DRUID 12  RANGER 13  MAGE_THIEF 14  CLERIC_MAGE 15  CLERIC_THIEF 16  FIGHTER_DRUID 17  FIGHTER_MAGE_CLERIC 18  CLERIC_RANGER 19 	SORCERER 20  MONK
							if char['class'] == 1:
								char['class'] = _('Mage')
							elif char['class'] == 2:
								char['class'] = _('Fighter')
							elif char['class'] == 3:
								char['class'] = _('Cleric')
							elif char['class'] == 4:
								char['class'] = _('Thief')
							elif char['class'] == 5:
								char['class'] = _('Bard')
							elif char['class'] == 6:
								char['class'] = _('Paladin')
							elif char['class'] == 7:
								char['class'] = _('Fighter/Mage')
							elif char['class'] == 8:
								char['class'] = _('Fighter/Cleric')
							elif char['class'] == 9:
								char['class'] = _('Fighter/Thief')
							elif char['class'] == 10:
								char['class'] = _('Fighter/Mage/Thief')
							elif char['class'] == 11:
								char['class'] = _('Druid')
							elif char['class'] == 12:
								char['class'] = _('Ranger')
							elif char['class'] == 13:
								char['class'] = _('Mage/Thief')
							elif char['class'] == 14:
								char['class'] = _('Cleric/Mage')
							elif char['class'] == 15:
								char['class'] = _('Cleric/Thief')
							elif char['class'] == 16:
								char['class'] = _('Fighter/Druid')
							elif char['class'] == 17:
								char['class'] = _('Fighter/Mage/Cleric')
							elif char['class'] == 18:
								char['class'] = _('Cleric/Ranger')
							elif char['class'] == 19:
								char['class'] = _('Sorcerer')
							elif char['class'] == 20:
								char['class'] = _('Monk')
							else:
								bugs = True
							char['gender'] = int(struct.unpack('b', text[a+0x0275:a+0x0275+1])[0]) # 1 -on, 2 - ona
							if char['gender'] == 1:
								char['gender'] = _('Male')
							elif char['gender'] == 2:
								char['gender'] = _('Female')
							else:
								bugs = True
							
							char['no_attack'] = int(struct.unpack('b', text[a+0x0053:a+0x0053+1])[0])
							char['death_save'] = int(struct.unpack('b', text[a+0x0054:a+0x0054+1])[0])
							char['wands_save'] = int(struct.unpack('b', text[a+0x0055:a+0x0055+1])[0])
							char['polymorph_save'] = int(struct.unpack('b', text[a+0x0056:a+0x0056+1])[0])
							char['breath_save'] = int(struct.unpack('b', text[a+0x0057:a+0x0057+1])[0])
							char['spells_save'] = int(struct.unpack('b', text[a+0x0058:a+0x0058+1])[0])
							char['fire'] = int(struct.unpack('b', text[a+0x0059:a+0x0059+1])[0])
							char['cold'] = int(struct.unpack('b', text[a+0x005a:a+0x005a+1])[0])
							char['elec'] = int(struct.unpack('b', text[a+0x005b:a+0x005b+1])[0])
							char['acid'] = int(struct.unpack('b', text[a+0x005c:a+0x005c+1])[0])
							char['magic'] = int(struct.unpack('b', text[a+0x005d:a+0x005d+1])[0])
							char['magic_fire'] = int(struct.unpack('b', text[a+0x005e:a+0x005e+1])[0])
							char['magic_cold'] = int(struct.unpack('b', text[a+0x005f:a+0x005f+1])[0])
							char['slash'] = int(struct.unpack('b', text[a+0x0060:a+0x0060+1])[0])
							char['crush'] = int(struct.unpack('b', text[a+0x0061:a+0x0061+1])[0])
							char['pierc'] = int(struct.unpack('b', text[a+0x0062:a+0x0062+1])[0])
							char['missile'] = int(struct.unpack('b', text[a+0x0063:a+0x0063+1])[0])
							char['ali'] = hex(int(struct.unpack('b', text[a+0x027b:a+0x027b+1])[0]))
							if char['ali'] == '0x11':
								char['ali'] = _('Lawful Good')
							elif char['ali'] == '0x12':
								char['ali'] = _('Lawful Neutral')
							elif char['ali'] == '0x12':
								char['ali'] = _('Lawful Neutral')
							elif char['ali'] == '0x13':
								char['ali'] = _('Lawful Evil')
							elif char['ali'] == '0x21':
								char['ali'] = _('Neutral Good')
							elif char['ali'] == '0x22':
								char['ali'] = _('Neutral')
							elif char['ali'] == '0x23':
								char['ali'] = _('Neutral Evil')
							elif char['ali'] == '0x31':
								char['ali'] = _('Chaotic Good')
							elif char['ali'] == '0x32':
								char['ali'] = _('Chaotic Neutral')
							elif char['ali'] == '0x33':
								char['ali'] = _('Chaotic Evil')
							else:
								bugs = True
							
							char['thac'] = int(struct.unpack('b', text[a+0x0052:a+0x0052+1])[0])
							char['levels1'] = int(struct.unpack('b', text[a+0x0234:a+0x0234+1])[0])
							char['levels2'] = int(struct.unpack('b', text[a+0x0235:a+0x0235+1])[0])
							if char['levels2'] > char['levels1']:
								char['levels1'] = char['levels2']
							
							if not bugs and char['fire'] < 101 and char['acid'] < 101 and char['crush'] < 101 and char['no_attack'] < 11 and char['dex'] < 26 and char['wis'] < 26:
								ch = Character(chr_file = nazwa_pliku, name= char['name'], xp=char['xp'], blunt=char['crush'], dex = char['dex'], hp=char['hp'], avatar=char['pic'], strength=char['str'], inteligence=char['int'], wisdom=char['wis'], charisma=char['char'], constitution=char['con'], race=char['race'], main_class=char['class'], gender=char['gender'], attacks=char['no_attack'], death_save=char['death_save'], wands_save=char['wands_save'], polymorph_save=char['polymorph_save'], breath_save=char['breath_save'], spells_save=char['spells_save'], fire=char['fire'], cold=char['cold'], elect=char['elec'], acid=char['acid'], magic=char['magic'], magic_fire=char['magic_fire'], magic_cold=char['magic_cold'], slash=char['slash'], pierce=char['pierc'], missile=char['missile'], thaco=char['thac'], levels=char['levels1'], kit='X', alingment=char['ali'], author=request.user, comment='X')
								ch.save()
							else:
								from os import remove
								remove(plik)
								errors['character'] = [_('Errors when reading data. Only Baldurs Gate CHR Character Files are allowed')]
								form = forms.FormWrapper(manipulator, new_data, errors)
								return render_to_response('baldur/add_file.html', {'form': form}, context_instance=RequestContext(request))
						else:
							from os import remove
							remove(plik)
							errors['character'] = [_('Unsuported CHR file version. Only Baldurs Gate CHR Character Files are allowed')]
							form = forms.FormWrapper(manipulator, new_data, errors)
							return render_to_response('baldur/add_file.html', {'form': form}, context_instance=RequestContext(request))
					else:
						from os import remove
						remove(plik)
						errors['character'] = [_('Invalid File. Only Baldurs Gate CHR Character Files are allowed')]
						form = forms.FormWrapper(manipulator, new_data, errors)
						return render_to_response('baldur/add_file.html', {'form': form}, context_instance=RequestContext(request))
					
				return HttpResponseRedirect('/bgate/add2/'+ str(ch.id) +'/')
		else:
			errors = new_data = {}
		form = forms.FormWrapper(manipulator, new_data, errors)
		return render_to_response('baldur/add_file.html', {'form': form}, context_instance=RequestContext(request))
	else:
		return HttpResponseRedirect("/user/")