from django.shortcuts import render_to_response
from django.conf import settings
from pages.models import *
from tasks.models import Task
from django.contrib.sites.models import Site
from django.template import RequestContext
from django.http import HttpResponseRedirect, HttpResponse
from boxcomments.models import Comment
from news.models import News

def show_index(request):
	from myghtyboard.models import Topic
	from userpanel.models import Profile
	from datetime import timedelta
	from datetime import datetime
	
	itopics = Topic.objects.all().values('id', 'topic_name', 'topic_last_pagination_page', 'topic_lastpost').order_by('-topic_modification_date')[:4]
	for t in itopics:
		lastposter = str(t['topic_lastpost'])
		br = lastposter.find('<br />')
		t['last'] = lastposter[:br]
	news = News.objects.select_related().order_by('-id')[:5]
	page = Page.objects.get(slug='index')
	pages = Page.objects.order_by('-id').values('slug', 'title')[:6]
	tasks = Task.objects.order_by('-modification_date').filter(status=True).values('id', 'name')[:4]
	com = Comment.objects.order_by('-id')[:4]
	now = datetime.now()
	check_time = now - timedelta(hours=1)
	onsite = Profile.objects.filter(onsitedata__gt=check_time).order_by('-onsitedata')[:5]
	from baldur.models import Character
	characters = Character.objects.order_by('-id').values('id', 'name', 'main_class')[:4]
	from translator.models import Translation
	tra = Translation.objects.order_by('-id').values('id', 'name')[:4]
	return render_to_response('pages/show_index.html', {'page': page, 'slug': 'index', 'itopics': itopics, 'inews': news, 'pages': pages, 'tasks': tasks, 'com': com, 'onsite': onsite, 'characters': characters, 'tra': tra}, context_instance=RequestContext(request))

def show(request, slug):
	if slug == 'index':
		return HttpResponseRedirect('/')
	try:
		page = Page.objects.select_related().get(slug=slug)
	except Page.DoesNotExist:
		return render_to_response('pages/bug.html', {'bug': _('Page does not exist')}, context_instance=RequestContext(request))
	domain = str(Site.objects.get_current()).replace('www.', '').replace('http://', '')
	crumb = ''
	a = page
	if a.parent:
		while a:
			crumb = '<a href="/w/p/' + a.parent.slug + '/">' + str(a.parent) + '</a> > ' + crumb
			a = a.parent
			if not a.parent:
				a = False
	if request.user.is_authenticated():
		staff = request.user.is_staff
		login = True
	else:
		staff = False
		login = False
	return render_to_response('pages/show.html', {'page': page, 'slug': slug, 'domain': domain, 'crumb': crumb[:-3], 'task': Task.objects.filter(page = page).count(), 'com': Comment.objects.filter(apptype= 1, appid = page.id).count(), 'staff': staff, 'login': login}, context_instance=RequestContext(request))

def show_plaintxt(request, slug):
	try:
		page = Page.objects.values('text').get(slug=slug)
	except Page.DoesNotExist:
		return render_to_response('pages/bug.html', {'bug': _('Page does not exist')}, context_instance=RequestContext(request))
	return HttpResponse(page['text'], mimetype="text/plain")

def sitemap(request):
	pages = Page.objects.values('slug', 'date', 'is_category').exclude(slug='index')
	news = News.objects.all()
	domain = str(Site.objects.get_current()).replace('www.', '').replace('http://', '')
	for p in pages:
		p['date'] = str(p['date'])[0:10]
	return render_to_response('pages/sitemap.html', {'pages': pages, 'news': news, 'domain': domain}, context_instance=RequestContext(request))

def rcs_rss(request):
	domain = str(Site.objects.get_current()).replace('www.', '').replace('http://', '')
	pages = Page.objects.values('slug', 'title', 'description', 'date').order_by('-id')[:10]
	news = News.objects.all().order_by('-id')[:10]
	return render_to_response('pages/rss2.html', {'pages': pages, 'news': news, 'domain': domain}, context_instance=RequestContext(request))

def search_pages(request):
	key = settings.GOOGLE_AJAX_KEY
	site = Site.objects.get_current()
	site = str(site)
	if request.POST:
		data = request.POST.copy()
		return render_to_response('pages/search.html', {'term': data['term'], 'site': site, 'key': key}, context_instance=RequestContext(request))
	else:
		return render_to_response('pages/search.html', {'site': site, 'key': key}, context_instance=RequestContext(request))


def biblioteki(request):
	return render_to_response('pages/biblioteki.html', context_instance=RequestContext(request))
def autor(request):
	return render_to_response('pages/autor.html', context_instance=RequestContext(request))