from django.shortcuts import render_to_response
from django import forms
from django.conf import settings
from translator.models import *
from django.contrib.sites.models import Site
from django.template import RequestContext
from django.http import HttpResponseRedirect, HttpResponse

def tra_list(request):
	tra = Translation.objects.select_related().order_by('percent_translated')
	return render_to_response('translator/tra_list.html', {'tra':  tra}, context_instance=RequestContext(request))

def tra_show(request, tid):
	tra = Translation.objects.get(id=tid)
	from boxcomments.models import Comment
	if tra.percent_translated != 100 and tra.untrans_entries < 100:
		import polib
		po = polib.pofile(settings.MEDIA_ROOT + tra.pofile)
		untrans = po.untranslated_entries()
		fuzzy = po.fuzzy_entries()
		return render_to_response('translator/tra_show.html', {'tra':  tra, 'untrans': untrans, 'fuzzy': fuzzy, 'com': Comment.objects.filter(apptype= 4, appid = tid).count()}, context_instance=RequestContext(request))
	return render_to_response('translator/tra_show.html', {'tra':  tra, 'com': Comment.objects.filter(apptype= 4, appid = tid).count()}, context_instance=RequestContext(request))

def get_po(request, tid):
	tra = Translation.objects.values('pofile').get(id=tid)
	po = open(settings.MEDIA_ROOT + tra['pofile']).read()
	#text/x-gettext-translation
	return HttpResponse(po, mimetype='application/x-gettext')

def translations(request):
	return render_to_response('translator/tra.html', context_instance=RequestContext(request))